// +build !generate_numeric

// ⚠️⚠️⚠️ This file was autogenerated by generators/expect/numeric ⚠️⚠️⚠️ //
package hit

import minitest "github.com/Eun/go-hit/internal/minitest"

// IExpectInt16 provides assertions for the int16 type.
type IExpectInt16 interface {
	// Equal expects the int16 to be equal to the specified value.
	Equal(value int16) IStep

	// NotEqual expects the int16 to be not equal to the specified value.
	NotEqual(value ...int16) IStep

	// OneOf expects the int16 to be equal to one of the specified values.
	OneOf(values ...int16) IStep

	// NotOneOf expects the int16 to be not equal to one of the specified values.
	NotOneOf(values ...int16) IStep

	// GreaterThan expects the int16 to be not greater than the specified value.
	GreaterThan(value int16) IStep

	// LessThan expects the int16 to be less than the specified value.
	LessThan(value int16) IStep

	// GreaterOrEqualThan expects the int16 to be greater or equal than the specified value.
	GreaterOrEqualThan(value int16) IStep

	// LessOrEqualThan expects the int16 to be less or equal than the specified value.
	LessOrEqualThan(value int16) IStep

	// Between expects the int16 to be between the specified min and max value (inclusive, min >= int16 >= max).
	Between(min, max int16) IStep

	// NotBetween expects the int16 to be not between the specified min and max value (inclusive, min >= int16 >= max).
	NotBetween(min, max int16) IStep
}
type expectInt16ValueCallback func(hit Hit) int16
type expectInt16 struct {
	cp            callPath
	valueCallback expectInt16ValueCallback
}

func newExpectInt16(cp callPath, valueCallback expectInt16ValueCallback) IExpectInt16 {
	return &expectInt16{cp: cp, valueCallback: valueCallback}
}
func (v *expectInt16) Equal(value int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Equal", []interface{}{value}), Exec: func(hit *hitImpl) error {
		return minitest.Error.Equal(v.valueCallback(hit), value)
	}}
}
func (v *expectInt16) NotEqual(values ...int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotEqual", int16SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.Error.NotEqual(v.valueCallback(hit), int16SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt16) OneOf(values ...int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("OneOf", int16SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.Error.OneOf(v.valueCallback(hit), int16SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt16) NotOneOf(values ...int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotOneOf", int16SliceToInterfaceSlice(values)), Exec: func(hit *hitImpl) error {
		return minitest.Error.NotOneOf(v.valueCallback(hit), int16SliceToInterfaceSlice(values)...)
	}}
}
func (v *expectInt16) GreaterThan(value int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l <= value {
			return minitest.Error.Errorf("expected %d to be greater than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt16) LessThan(value int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= value {
			return minitest.Error.Errorf("expected %d to be less than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt16) GreaterOrEqualThan(value int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("GreaterOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < value {
			return minitest.Error.Errorf("expected %d to be greater or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt16) LessOrEqualThan(value int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("LessOrEqualThan", []interface{}{value}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l > value {
			return minitest.Error.Errorf("expected %d to be less or equal than %d", l, value)
		}
		return nil
	}}
}
func (v *expectInt16) Between(min, max int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("Between", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l < min || l > max {
			return minitest.Error.Errorf("expected %d to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
func (v *expectInt16) NotBetween(min, max int16) IStep {
	return &hitStep{Trace: ett.Prepare(), When: ExpectStep, CallPath: v.cp.Push("NotBetween", []interface{}{min, max}), Exec: func(hit *hitImpl) error {
		l := v.valueCallback(hit)
		if l >= min && l <= max {
			return minitest.Error.Errorf("expected %d not to be between %d and %d", l, min, max)
		}
		return nil
	}}
}
