// ⚠️⚠️⚠️ This file was autogenerated by generators/clear/tests ⚠️⚠️⚠️ //
package hit_test

import (
	"testing"

	. "github.com/Eun/go-hit"
	"github.com/stretchr/testify/require"
)

func storeSteps(steps *[]IStep) IStep {
	return Custom(CleanStep, func(hit Hit) {
		*steps = hit.Steps()
	})
}
func expectSteps(t *testing.T, expectSteps *[]IStep, removedStepsCount int) IStep {
	return Custom(BeforeExpectStep, func(hit Hit) {
		require.Len(t, hit.Steps(), len(*expectSteps)-removedStepsCount)
		panic("TestOK")
	})
}

func TestGenClear_Generic_Send(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bool(false),
			Send().Body().Bool(true),
			storeSteps(&steps),
			Clear().Send(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBody(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bool(false),
			Send().Body().Bool(true),
			storeSteps(&steps),
			Clear().Send().Body(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyBool(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bool(false),
			Send().Body().Bool(true),
			storeSteps(&steps),
			Clear().Send().Body().Bool(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyBool(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bool(false),
			Send().Body().Bool(true),
			storeSteps(&steps),
			Clear().Send().Body().Bool(false),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyBytes(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bytes([]uint8{0x1, 0x2}),
			Send().Body().Bytes([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Send().Body().Bytes(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyBytes(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Bytes([]uint8{0x1, 0x2}),
			Send().Body().Bytes([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Send().Body().Bytes([]uint8{0x1, 0x2}),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyFloat32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Float32(1.000000),
			Send().Body().Float32(3.000000),
			storeSteps(&steps),
			Clear().Send().Body().Float32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyFloat32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Float32(1.000000),
			Send().Body().Float32(3.000000),
			storeSteps(&steps),
			Clear().Send().Body().Float32(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyFloat64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Float64(1.000000),
			Send().Body().Float64(3.000000),
			storeSteps(&steps),
			Clear().Send().Body().Float64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyFloat64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Float64(1.000000),
			Send().Body().Float64(3.000000),
			storeSteps(&steps),
			Clear().Send().Body().Float64(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyFormValues(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().FormValues("Foo-Bar").Add("Foo", "Baz"),
			Send().Body().FormValues("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Body().FormValues(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyFormValuesAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().FormValues("Foo-Bar").Add("Foo", "Baz"),
			Send().Body().FormValues("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Body().FormValues().Add(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyFormValuesAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().FormValues("Foo-Bar").Add("Foo", "Baz"),
			Send().Body().FormValues("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Body().FormValues("Foo-Bar").Add("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyInt(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int(2),
			Send().Body().Int(3),
			storeSteps(&steps),
			Clear().Send().Body().Int(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyInt(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int(2),
			Send().Body().Int(3),
			storeSteps(&steps),
			Clear().Send().Body().Int(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyInt16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int16(2),
			Send().Body().Int16(3),
			storeSteps(&steps),
			Clear().Send().Body().Int16(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyInt16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int16(2),
			Send().Body().Int16(3),
			storeSteps(&steps),
			Clear().Send().Body().Int16(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyInt32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int32(2),
			Send().Body().Int32(3),
			storeSteps(&steps),
			Clear().Send().Body().Int32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyInt32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int32(2),
			Send().Body().Int32(3),
			storeSteps(&steps),
			Clear().Send().Body().Int32(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyInt64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int64(2),
			Send().Body().Int64(3),
			storeSteps(&steps),
			Clear().Send().Body().Int64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyInt64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int64(2),
			Send().Body().Int64(3),
			storeSteps(&steps),
			Clear().Send().Body().Int64(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyInt8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int8(2),
			Send().Body().Int8(3),
			storeSteps(&steps),
			Clear().Send().Body().Int8(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyInt8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Int8(2),
			Send().Body().Int8(3),
			storeSteps(&steps),
			Clear().Send().Body().Int8(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyJSON(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().JSON("Foo-Taz"),
			Send().Body().JSON("Hello-Universe"),
			storeSteps(&steps),
			Clear().Send().Body().JSON(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyJSON(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().JSON("Foo-Taz"),
			Send().Body().JSON("Hello-Universe"),
			storeSteps(&steps),
			Clear().Send().Body().JSON("Foo-Taz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyString(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().String("Foo-Bar"),
			Send().Body().String("Hello-World"),
			storeSteps(&steps),
			Clear().Send().Body().String(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyString(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().String("Foo-Bar"),
			Send().Body().String("Hello-World"),
			storeSteps(&steps),
			Clear().Send().Body().String("Foo-Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyUint(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint(0x2),
			Send().Body().Uint(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyUint(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint(0x2),
			Send().Body().Uint(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyUint16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint16(0x2),
			Send().Body().Uint16(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint16(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyUint16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint16(0x2),
			Send().Body().Uint16(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint16(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyUint32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint32(0x2),
			Send().Body().Uint32(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyUint32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint32(0x2),
			Send().Body().Uint32(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint32(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyUint64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint64(0x2),
			Send().Body().Uint64(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyUint64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint64(0x2),
			Send().Body().Uint64(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint64(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyUint8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint8(0x2),
			Send().Body().Uint8(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint8(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyUint8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().Uint8(0x2),
			Send().Body().Uint8(0x3),
			storeSteps(&steps),
			Clear().Send().Body().Uint8(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendBodyXML(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().XML("Foo-Taz"),
			Send().Body().XML("Hello-Universe"),
			storeSteps(&steps),
			Clear().Send().Body().XML(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendBodyXML(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Body().XML("Foo-Taz"),
			Send().Body().XML("Hello-Universe"),
			storeSteps(&steps),
			Clear().Send().Body().XML("Foo-Taz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendHeaders(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Headers("Foo-Bar").Add("Foo", "Baz"),
			Send().Headers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Headers(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendHeadersAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Headers("Foo-Bar").Add("Foo", "Baz"),
			Send().Headers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Headers().Add(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendHeadersAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Headers("Foo-Bar").Add("Foo", "Baz"),
			Send().Headers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Headers("Foo-Bar").Add("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendTrailers(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Trailers("Foo-Bar").Add("Foo", "Baz"),
			Send().Trailers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Trailers(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_SendTrailersAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Trailers("Foo-Bar").Add("Foo", "Baz"),
			Send().Trailers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Trailers().Add(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_SendTrailersAdd(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Send().Trailers("Foo-Bar").Add("Foo", "Baz"),
			Send().Trailers("Hello-World").Add("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Send().Trailers("Foo-Bar").Add("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_Expect(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Contains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBody(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Contains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytes(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Contains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Contains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Contains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Contains([]uint8{0x1, 0x2}),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Equal([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Equal([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Equal([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().Equal([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Equal([]uint8{0x1, 0x2}),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().Between(2, 2),
			Expect().Body().Bytes().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().Between(2, 2),
			Expect().Body().Bytes().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().Between(2, 2),
			Expect().Body().Bytes().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().Equal(2),
			Expect().Body().Bytes().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().Equal(2),
			Expect().Body().Bytes().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().GreaterOrEqualThan(2),
			Expect().Body().Bytes().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().GreaterOrEqualThan(2),
			Expect().Body().Bytes().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().GreaterThan(2),
			Expect().Body().Bytes().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().GreaterThan(2),
			Expect().Body().Bytes().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().LessOrEqualThan(2),
			Expect().Body().Bytes().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().LessOrEqualThan(2),
			Expect().Body().Bytes().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().LessThan(2),
			Expect().Body().Bytes().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().LessThan(2),
			Expect().Body().Bytes().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotBetween(2, 2),
			Expect().Body().Bytes().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotBetween(2, 2),
			Expect().Body().Bytes().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotEqual(1, 2),
			Expect().Body().Bytes().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotEqual(1, 2),
			Expect().Body().Bytes().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotOneOf(1, 2),
			Expect().Body().Bytes().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().NotOneOf(1, 2),
			Expect().Body().Bytes().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().OneOf(1, 2),
			Expect().Body().Bytes().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().Len().OneOf(1, 2),
			Expect().Body().Bytes().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().NotContains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().NotContains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().NotContains([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().NotContains([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().NotContains([]uint8{0x1, 0x2}),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyBytesNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().NotEqual([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().NotEqual([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyBytesNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Bytes().NotEqual([]uint8{0x1, 0x2}),
			Expect().Body().Bytes().NotEqual([]uint8{0x3, 0x4}),
			storeSteps(&steps),
			Clear().Expect().Body().Bytes().NotEqual([]uint8{0x1, 0x2}),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().Between(1.000000, 1.000000),
			Expect().Body().Float32().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().Between(1.000000, 1.000000),
			Expect().Body().Float32().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().Between(1.000000, 1.000000),
			Expect().Body().Float32().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().Between(1.000000, 1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().Equal(1.000000),
			Expect().Body().Float32().Equal(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().Equal(1.000000),
			Expect().Body().Float32().Equal(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().Equal(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().GreaterOrEqualThan(1.000000),
			Expect().Body().Float32().GreaterOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().GreaterOrEqualThan(1.000000),
			Expect().Body().Float32().GreaterOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().GreaterOrEqualThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().GreaterThan(1.000000),
			Expect().Body().Float32().GreaterThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().GreaterThan(1.000000),
			Expect().Body().Float32().GreaterThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().GreaterThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().LessOrEqualThan(1.000000),
			Expect().Body().Float32().LessOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().LessOrEqualThan(1.000000),
			Expect().Body().Float32().LessOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().LessOrEqualThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().LessThan(1.000000),
			Expect().Body().Float32().LessThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().LessThan(1.000000),
			Expect().Body().Float32().LessThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().LessThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotBetween(1.000000, 1.000000),
			Expect().Body().Float32().NotBetween(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotBetween(1.000000, 1.000000),
			Expect().Body().Float32().NotBetween(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotBetween(1.000000, 1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotEqual(1.000000, 2.000000),
			Expect().Body().Float32().NotEqual(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotEqual(1.000000, 2.000000),
			Expect().Body().Float32().NotEqual(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotEqual(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotOneOf(1.000000, 2.000000),
			Expect().Body().Float32().NotOneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().NotOneOf(1.000000, 2.000000),
			Expect().Body().Float32().NotOneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().NotOneOf(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().OneOf(1.000000, 2.000000),
			Expect().Body().Float32().OneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float32().OneOf(1.000000, 2.000000),
			Expect().Body().Float32().OneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float32().OneOf(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().Between(1.000000, 1.000000),
			Expect().Body().Float64().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().Between(1.000000, 1.000000),
			Expect().Body().Float64().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().Between(1.000000, 1.000000),
			Expect().Body().Float64().Between(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().Between(1.000000, 1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().Equal(1.000000),
			Expect().Body().Float64().Equal(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().Equal(1.000000),
			Expect().Body().Float64().Equal(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().Equal(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().GreaterOrEqualThan(1.000000),
			Expect().Body().Float64().GreaterOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().GreaterOrEqualThan(1.000000),
			Expect().Body().Float64().GreaterOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().GreaterOrEqualThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().GreaterThan(1.000000),
			Expect().Body().Float64().GreaterThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().GreaterThan(1.000000),
			Expect().Body().Float64().GreaterThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().GreaterThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().LessOrEqualThan(1.000000),
			Expect().Body().Float64().LessOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().LessOrEqualThan(1.000000),
			Expect().Body().Float64().LessOrEqualThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().LessOrEqualThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().LessThan(1.000000),
			Expect().Body().Float64().LessThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().LessThan(1.000000),
			Expect().Body().Float64().LessThan(3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().LessThan(1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotBetween(1.000000, 1.000000),
			Expect().Body().Float64().NotBetween(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotBetween(1.000000, 1.000000),
			Expect().Body().Float64().NotBetween(3.000000, 3.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotBetween(1.000000, 1.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotEqual(1.000000, 2.000000),
			Expect().Body().Float64().NotEqual(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotEqual(1.000000, 2.000000),
			Expect().Body().Float64().NotEqual(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotEqual(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotOneOf(1.000000, 2.000000),
			Expect().Body().Float64().NotOneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().NotOneOf(1.000000, 2.000000),
			Expect().Body().Float64().NotOneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().NotOneOf(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFloat64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().OneOf(1.000000, 2.000000),
			Expect().Body().Float64().OneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFloat64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Float64().OneOf(1.000000, 2.000000),
			Expect().Body().Float64().OneOf(3.000000, 4.000000),
			storeSteps(&steps),
			Clear().Expect().Body().Float64().OneOf(1.000000, 2.000000),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValues(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Empty(),
			Expect().Body().FormValues("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Empty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Empty(),
			Expect().Body().FormValues("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Empty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Equal("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().Between(2, 2),
			Expect().Body().FormValues("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().Between(2, 2),
			Expect().Body().FormValues("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().Between(2, 2),
			Expect().Body().FormValues("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().Equal(2),
			Expect().Body().FormValues("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().Equal(2),
			Expect().Body().FormValues("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Body().FormValues("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Body().FormValues("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().GreaterThan(2),
			Expect().Body().FormValues("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().GreaterThan(2),
			Expect().Body().FormValues("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Body().FormValues("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Body().FormValues("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().LessThan(2),
			Expect().Body().FormValues("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().LessThan(2),
			Expect().Body().FormValues("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Body().FormValues("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Body().FormValues("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Body().FormValues("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Body().FormValues("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Body().FormValues("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Body().FormValues("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().OneOf(1, 2),
			Expect().Body().FormValues("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").Len().OneOf(1, 2),
			Expect().Body().FormValues("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotEmpty(),
			Expect().Body().FormValues("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().NotEmpty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotEmpty(),
			Expect().Body().FormValues("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").NotEmpty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").NotOneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyFormValuesOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyFormValuesOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().FormValues("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Body().FormValues("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().FormValues("Foo-Bar").OneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().Between(2, 2),
			Expect().Body().Int().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().Between(2, 2),
			Expect().Body().Int().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().Between(2, 2),
			Expect().Body().Int().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().Equal(2),
			Expect().Body().Int().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().Equal(2),
			Expect().Body().Int().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().GreaterOrEqualThan(2),
			Expect().Body().Int().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().GreaterOrEqualThan(2),
			Expect().Body().Int().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().GreaterThan(2),
			Expect().Body().Int().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().GreaterThan(2),
			Expect().Body().Int().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().LessOrEqualThan(2),
			Expect().Body().Int().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().LessOrEqualThan(2),
			Expect().Body().Int().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().LessThan(2),
			Expect().Body().Int().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().LessThan(2),
			Expect().Body().Int().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotBetween(2, 2),
			Expect().Body().Int().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotBetween(2, 2),
			Expect().Body().Int().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotEqual(1, 2),
			Expect().Body().Int().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotEqual(1, 2),
			Expect().Body().Int().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotOneOf(1, 2),
			Expect().Body().Int().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().NotOneOf(1, 2),
			Expect().Body().Int().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyIntOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().OneOf(1, 2),
			Expect().Body().Int().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyIntOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int().OneOf(1, 2),
			Expect().Body().Int().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().Between(2, 2),
			Expect().Body().Int16().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().Between(2, 2),
			Expect().Body().Int16().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().Between(2, 2),
			Expect().Body().Int16().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().Equal(2),
			Expect().Body().Int16().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().Equal(2),
			Expect().Body().Int16().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().GreaterOrEqualThan(2),
			Expect().Body().Int16().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().GreaterOrEqualThan(2),
			Expect().Body().Int16().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().GreaterThan(2),
			Expect().Body().Int16().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().GreaterThan(2),
			Expect().Body().Int16().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().LessOrEqualThan(2),
			Expect().Body().Int16().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().LessOrEqualThan(2),
			Expect().Body().Int16().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().LessThan(2),
			Expect().Body().Int16().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().LessThan(2),
			Expect().Body().Int16().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotBetween(2, 2),
			Expect().Body().Int16().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotBetween(2, 2),
			Expect().Body().Int16().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotEqual(1, 2),
			Expect().Body().Int16().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotEqual(1, 2),
			Expect().Body().Int16().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotOneOf(1, 2),
			Expect().Body().Int16().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().NotOneOf(1, 2),
			Expect().Body().Int16().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt16OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().OneOf(1, 2),
			Expect().Body().Int16().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt16OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int16().OneOf(1, 2),
			Expect().Body().Int16().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int16().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().Between(2, 2),
			Expect().Body().Int32().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().Between(2, 2),
			Expect().Body().Int32().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().Between(2, 2),
			Expect().Body().Int32().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().Equal(2),
			Expect().Body().Int32().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().Equal(2),
			Expect().Body().Int32().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().GreaterOrEqualThan(2),
			Expect().Body().Int32().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().GreaterOrEqualThan(2),
			Expect().Body().Int32().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().GreaterThan(2),
			Expect().Body().Int32().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().GreaterThan(2),
			Expect().Body().Int32().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().LessOrEqualThan(2),
			Expect().Body().Int32().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().LessOrEqualThan(2),
			Expect().Body().Int32().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().LessThan(2),
			Expect().Body().Int32().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().LessThan(2),
			Expect().Body().Int32().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotBetween(2, 2),
			Expect().Body().Int32().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotBetween(2, 2),
			Expect().Body().Int32().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotEqual(1, 2),
			Expect().Body().Int32().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotEqual(1, 2),
			Expect().Body().Int32().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotOneOf(1, 2),
			Expect().Body().Int32().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().NotOneOf(1, 2),
			Expect().Body().Int32().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().OneOf(1, 2),
			Expect().Body().Int32().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int32().OneOf(1, 2),
			Expect().Body().Int32().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int32().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().Between(2, 2),
			Expect().Body().Int64().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().Between(2, 2),
			Expect().Body().Int64().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().Between(2, 2),
			Expect().Body().Int64().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().Equal(2),
			Expect().Body().Int64().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().Equal(2),
			Expect().Body().Int64().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().GreaterOrEqualThan(2),
			Expect().Body().Int64().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().GreaterOrEqualThan(2),
			Expect().Body().Int64().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().GreaterThan(2),
			Expect().Body().Int64().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().GreaterThan(2),
			Expect().Body().Int64().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().LessOrEqualThan(2),
			Expect().Body().Int64().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().LessOrEqualThan(2),
			Expect().Body().Int64().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().LessThan(2),
			Expect().Body().Int64().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().LessThan(2),
			Expect().Body().Int64().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotBetween(2, 2),
			Expect().Body().Int64().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotBetween(2, 2),
			Expect().Body().Int64().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotEqual(1, 2),
			Expect().Body().Int64().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotEqual(1, 2),
			Expect().Body().Int64().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotOneOf(1, 2),
			Expect().Body().Int64().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().NotOneOf(1, 2),
			Expect().Body().Int64().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().OneOf(1, 2),
			Expect().Body().Int64().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int64().OneOf(1, 2),
			Expect().Body().Int64().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int64().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().Between(2, 2),
			Expect().Body().Int8().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().Between(2, 2),
			Expect().Body().Int8().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().Between(2, 2),
			Expect().Body().Int8().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().Equal(2),
			Expect().Body().Int8().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().Equal(2),
			Expect().Body().Int8().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().GreaterOrEqualThan(2),
			Expect().Body().Int8().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().GreaterOrEqualThan(2),
			Expect().Body().Int8().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().GreaterThan(2),
			Expect().Body().Int8().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().GreaterThan(2),
			Expect().Body().Int8().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().LessOrEqualThan(2),
			Expect().Body().Int8().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().LessOrEqualThan(2),
			Expect().Body().Int8().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().LessThan(2),
			Expect().Body().Int8().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().LessThan(2),
			Expect().Body().Int8().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotBetween(2, 2),
			Expect().Body().Int8().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotBetween(2, 2),
			Expect().Body().Int8().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotEqual(1, 2),
			Expect().Body().Int8().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotEqual(1, 2),
			Expect().Body().Int8().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotOneOf(1, 2),
			Expect().Body().Int8().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().NotOneOf(1, 2),
			Expect().Body().Int8().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyInt8OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().OneOf(1, 2),
			Expect().Body().Int8().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyInt8OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Int8().OneOf(1, 2),
			Expect().Body().Int8().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().Int8().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSON(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Contains("Foo", "Baz"),
			Expect().Body().JSON().Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Contains("Foo", "Baz"),
			Expect().Body().JSON().Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Contains("Foo", "Baz"),
			Expect().Body().JSON().Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Equal("Foo-Taz"),
			Expect().Body().JSON().Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Equal("Foo-Taz"),
			Expect().Body().JSON().Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Equal("Foo-Taz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQ(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Equal("Foo-Taz"),
			Expect().Body().JSON().JQ("Hello", "World").Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Equal("Foo-Taz"),
			Expect().Body().JSON().JQ("Hello", "World").Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Equal("Foo-Taz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQ(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQJQContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Equal("Foo-Taz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQJQEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Equal("Foo-Taz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Equal("Hello-Universe"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Equal("Foo-Taz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQJQ(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").JQ("Foo", "Bar").Contains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").JQ("Hello", "World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().JQ(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").Len().Between(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQJQNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQJQNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().JQ().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQJQNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").JQ("Hello", "World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().Between(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().Between(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().Between(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().Equal(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().Equal(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterOrEqualThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterOrEqualThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().LessOrEqualThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().LessOrEqualThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().LessThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().LessThan(2),
			Expect().Body().JSON().JQ("Hello", "World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotBetween(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotBetween(2, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotEqual(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotEqual(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotOneOf(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().NotOneOf(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().OneOf(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").Len().OneOf(1, 2),
			Expect().Body().JSON().JQ("Hello", "World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONJQNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONJQNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			Expect().Body().JSON().JQ("Hello", "World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().JQ("Foo", "Bar").NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().Between(2, 2),
			Expect().Body().JSON().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().Between(2, 2),
			Expect().Body().JSON().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().Between(2, 2),
			Expect().Body().JSON().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().Equal(2),
			Expect().Body().JSON().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().Equal(2),
			Expect().Body().JSON().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().GreaterOrEqualThan(2),
			Expect().Body().JSON().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().GreaterOrEqualThan(2),
			Expect().Body().JSON().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().GreaterThan(2),
			Expect().Body().JSON().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().GreaterThan(2),
			Expect().Body().JSON().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().LessOrEqualThan(2),
			Expect().Body().JSON().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().LessOrEqualThan(2),
			Expect().Body().JSON().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().LessThan(2),
			Expect().Body().JSON().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().LessThan(2),
			Expect().Body().JSON().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotBetween(2, 2),
			Expect().Body().JSON().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotBetween(2, 2),
			Expect().Body().JSON().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotEqual(1, 2),
			Expect().Body().JSON().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotEqual(1, 2),
			Expect().Body().JSON().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotOneOf(1, 2),
			Expect().Body().JSON().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().NotOneOf(1, 2),
			Expect().Body().JSON().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().OneOf(1, 2),
			Expect().Body().JSON().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().Len().OneOf(1, 2),
			Expect().Body().JSON().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().NotContains("Foo", "Baz"),
			Expect().Body().JSON().NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().NotContains("Foo", "Baz"),
			Expect().Body().JSON().NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyJSONNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().NotEqual("Foo", "Baz"),
			Expect().Body().JSON().NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyJSONNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().JSON().NotEqual("Foo", "Baz"),
			Expect().Body().JSON().NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Body().JSON().NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyString(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Contains("Foo-Bar"),
			Expect().Body().String().Contains("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Contains("Foo-Bar"),
			Expect().Body().String().Contains("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Contains("Foo-Bar"),
			Expect().Body().String().Contains("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().Contains("Foo-Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Equal("Foo-Bar"),
			Expect().Body().String().Equal("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Equal("Foo-Bar"),
			Expect().Body().String().Equal("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().Equal("Foo-Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().Between(2, 2),
			Expect().Body().String().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().Between(2, 2),
			Expect().Body().String().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().Between(2, 2),
			Expect().Body().String().Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().Equal(2),
			Expect().Body().String().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().Equal(2),
			Expect().Body().String().Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().GreaterOrEqualThan(2),
			Expect().Body().String().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().GreaterOrEqualThan(2),
			Expect().Body().String().Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().GreaterThan(2),
			Expect().Body().String().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().GreaterThan(2),
			Expect().Body().String().Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().LessOrEqualThan(2),
			Expect().Body().String().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().LessOrEqualThan(2),
			Expect().Body().String().Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().LessThan(2),
			Expect().Body().String().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().LessThan(2),
			Expect().Body().String().Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotBetween(2, 2),
			Expect().Body().String().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotBetween(2, 2),
			Expect().Body().String().Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotEqual(1, 2),
			Expect().Body().String().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotEqual(1, 2),
			Expect().Body().String().Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotOneOf(1, 2),
			Expect().Body().String().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().NotOneOf(1, 2),
			Expect().Body().String().Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().OneOf(1, 2),
			Expect().Body().String().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().Len().OneOf(1, 2),
			Expect().Body().String().Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Body().String().Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotContains("Foo-Bar"),
			Expect().Body().String().NotContains("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotContains("Foo-Bar"),
			Expect().Body().String().NotContains("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotContains("Foo-Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotEqual("Foo-Bar"),
			Expect().Body().String().NotEqual("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotEqual("Foo-Bar"),
			Expect().Body().String().NotEqual("Hello-World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotEqual("Foo-Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotOneOf("Foo", "Bar"),
			Expect().Body().String().NotOneOf("Hello", "World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().NotOneOf("Foo", "Bar"),
			Expect().Body().String().NotOneOf("Hello", "World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().NotOneOf("Foo", "Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyStringOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().OneOf("Foo", "Bar"),
			Expect().Body().String().OneOf("Hello", "World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyStringOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().String().OneOf("Foo", "Bar"),
			Expect().Body().String().OneOf("Hello", "World"),
			storeSteps(&steps),
			Clear().Expect().Body().String().OneOf("Foo", "Bar"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().Between(0x2, 0x2),
			Expect().Body().Uint().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().Between(0x2, 0x2),
			Expect().Body().Uint().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().Between(0x2, 0x2),
			Expect().Body().Uint().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().Between(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().Equal(0x2),
			Expect().Body().Uint().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().Equal(0x2),
			Expect().Body().Uint().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().Equal(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().GreaterOrEqualThan(0x2),
			Expect().Body().Uint().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().GreaterOrEqualThan(0x2),
			Expect().Body().Uint().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().GreaterOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().GreaterThan(0x2),
			Expect().Body().Uint().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().GreaterThan(0x2),
			Expect().Body().Uint().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().GreaterThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().LessOrEqualThan(0x2),
			Expect().Body().Uint().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().LessOrEqualThan(0x2),
			Expect().Body().Uint().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().LessOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().LessThan(0x2),
			Expect().Body().Uint().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().LessThan(0x2),
			Expect().Body().Uint().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().LessThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotBetween(0x2, 0x2),
			Expect().Body().Uint().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotBetween(0x2, 0x2),
			Expect().Body().Uint().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotBetween(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotEqual(0x1, 0x2),
			Expect().Body().Uint().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotEqual(0x1, 0x2),
			Expect().Body().Uint().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotEqual(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotOneOf(0x1, 0x2),
			Expect().Body().Uint().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().NotOneOf(0x1, 0x2),
			Expect().Body().Uint().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().NotOneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUintOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().OneOf(0x1, 0x2),
			Expect().Body().Uint().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUintOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint().OneOf(0x1, 0x2),
			Expect().Body().Uint().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint().OneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().Between(0x2, 0x2),
			Expect().Body().Uint16().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().Between(0x2, 0x2),
			Expect().Body().Uint16().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().Between(0x2, 0x2),
			Expect().Body().Uint16().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().Between(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().Equal(0x2),
			Expect().Body().Uint16().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().Equal(0x2),
			Expect().Body().Uint16().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().Equal(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().GreaterOrEqualThan(0x2),
			Expect().Body().Uint16().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().GreaterOrEqualThan(0x2),
			Expect().Body().Uint16().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().GreaterOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().GreaterThan(0x2),
			Expect().Body().Uint16().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().GreaterThan(0x2),
			Expect().Body().Uint16().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().GreaterThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().LessOrEqualThan(0x2),
			Expect().Body().Uint16().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().LessOrEqualThan(0x2),
			Expect().Body().Uint16().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().LessOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().LessThan(0x2),
			Expect().Body().Uint16().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().LessThan(0x2),
			Expect().Body().Uint16().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().LessThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotBetween(0x2, 0x2),
			Expect().Body().Uint16().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotBetween(0x2, 0x2),
			Expect().Body().Uint16().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotBetween(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotEqual(0x1, 0x2),
			Expect().Body().Uint16().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotEqual(0x1, 0x2),
			Expect().Body().Uint16().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotEqual(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotOneOf(0x1, 0x2),
			Expect().Body().Uint16().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().NotOneOf(0x1, 0x2),
			Expect().Body().Uint16().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().NotOneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint16OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().OneOf(0x1, 0x2),
			Expect().Body().Uint16().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint16OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint16().OneOf(0x1, 0x2),
			Expect().Body().Uint16().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint16().OneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().Between(0x2, 0x2),
			Expect().Body().Uint32().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().Between(0x2, 0x2),
			Expect().Body().Uint32().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().Between(0x2, 0x2),
			Expect().Body().Uint32().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().Between(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().Equal(0x2),
			Expect().Body().Uint32().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().Equal(0x2),
			Expect().Body().Uint32().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().Equal(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().GreaterOrEqualThan(0x2),
			Expect().Body().Uint32().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().GreaterOrEqualThan(0x2),
			Expect().Body().Uint32().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().GreaterOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().GreaterThan(0x2),
			Expect().Body().Uint32().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().GreaterThan(0x2),
			Expect().Body().Uint32().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().GreaterThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().LessOrEqualThan(0x2),
			Expect().Body().Uint32().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().LessOrEqualThan(0x2),
			Expect().Body().Uint32().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().LessOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().LessThan(0x2),
			Expect().Body().Uint32().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().LessThan(0x2),
			Expect().Body().Uint32().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().LessThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotBetween(0x2, 0x2),
			Expect().Body().Uint32().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotBetween(0x2, 0x2),
			Expect().Body().Uint32().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotBetween(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotEqual(0x1, 0x2),
			Expect().Body().Uint32().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotEqual(0x1, 0x2),
			Expect().Body().Uint32().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotEqual(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotOneOf(0x1, 0x2),
			Expect().Body().Uint32().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().NotOneOf(0x1, 0x2),
			Expect().Body().Uint32().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().NotOneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().OneOf(0x1, 0x2),
			Expect().Body().Uint32().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint32OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint32().OneOf(0x1, 0x2),
			Expect().Body().Uint32().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint32().OneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().Between(0x2, 0x2),
			Expect().Body().Uint64().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().Between(0x2, 0x2),
			Expect().Body().Uint64().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().Between(0x2, 0x2),
			Expect().Body().Uint64().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().Between(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().Equal(0x2),
			Expect().Body().Uint64().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().Equal(0x2),
			Expect().Body().Uint64().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().Equal(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().GreaterOrEqualThan(0x2),
			Expect().Body().Uint64().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().GreaterOrEqualThan(0x2),
			Expect().Body().Uint64().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().GreaterOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().GreaterThan(0x2),
			Expect().Body().Uint64().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().GreaterThan(0x2),
			Expect().Body().Uint64().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().GreaterThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().LessOrEqualThan(0x2),
			Expect().Body().Uint64().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().LessOrEqualThan(0x2),
			Expect().Body().Uint64().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().LessOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().LessThan(0x2),
			Expect().Body().Uint64().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().LessThan(0x2),
			Expect().Body().Uint64().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().LessThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotBetween(0x2, 0x2),
			Expect().Body().Uint64().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotBetween(0x2, 0x2),
			Expect().Body().Uint64().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotBetween(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotEqual(0x1, 0x2),
			Expect().Body().Uint64().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotEqual(0x1, 0x2),
			Expect().Body().Uint64().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotEqual(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotOneOf(0x1, 0x2),
			Expect().Body().Uint64().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().NotOneOf(0x1, 0x2),
			Expect().Body().Uint64().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().NotOneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().OneOf(0x1, 0x2),
			Expect().Body().Uint64().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint64OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint64().OneOf(0x1, 0x2),
			Expect().Body().Uint64().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint64().OneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().Between(0x2, 0x2),
			Expect().Body().Uint8().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().Between(0x2, 0x2),
			Expect().Body().Uint8().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8Between(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().Between(0x2, 0x2),
			Expect().Body().Uint8().Between(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().Between(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().Equal(0x2),
			Expect().Body().Uint8().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8Equal(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().Equal(0x2),
			Expect().Body().Uint8().Equal(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().Equal(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().GreaterOrEqualThan(0x2),
			Expect().Body().Uint8().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8GreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().GreaterOrEqualThan(0x2),
			Expect().Body().Uint8().GreaterOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().GreaterOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().GreaterThan(0x2),
			Expect().Body().Uint8().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8GreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().GreaterThan(0x2),
			Expect().Body().Uint8().GreaterThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().GreaterThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().LessOrEqualThan(0x2),
			Expect().Body().Uint8().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8LessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().LessOrEqualThan(0x2),
			Expect().Body().Uint8().LessOrEqualThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().LessOrEqualThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().LessThan(0x2),
			Expect().Body().Uint8().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8LessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().LessThan(0x2),
			Expect().Body().Uint8().LessThan(0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().LessThan(0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotBetween(0x2, 0x2),
			Expect().Body().Uint8().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8NotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotBetween(0x2, 0x2),
			Expect().Body().Uint8().NotBetween(0x3, 0x3),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotBetween(0x2, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotEqual(0x1, 0x2),
			Expect().Body().Uint8().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8NotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotEqual(0x1, 0x2),
			Expect().Body().Uint8().NotEqual(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotEqual(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotOneOf(0x1, 0x2),
			Expect().Body().Uint8().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8NotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().NotOneOf(0x1, 0x2),
			Expect().Body().Uint8().NotOneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().NotOneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectBodyUint8OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().OneOf(0x1, 0x2),
			Expect().Body().Uint8().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectBodyUint8OneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Body().Uint8().OneOf(0x1, 0x2),
			Expect().Body().Uint8().OneOf(0x3, 0x4),
			storeSteps(&steps),
			Clear().Expect().Body().Uint8().OneOf(0x1, 0x2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeaders(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Headers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Headers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Headers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Empty(),
			Expect().Headers("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Headers().Empty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Empty(),
			Expect().Headers("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Empty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Headers("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Headers("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Equal("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().Between(2, 2),
			Expect().Headers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().Between(2, 2),
			Expect().Headers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().Between(2, 2),
			Expect().Headers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().Equal(2),
			Expect().Headers("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().Equal(2),
			Expect().Headers("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Headers("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Headers("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().GreaterThan(2),
			Expect().Headers("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().GreaterThan(2),
			Expect().Headers("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Headers("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Headers("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().LessThan(2),
			Expect().Headers("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().LessThan(2),
			Expect().Headers("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Headers("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Headers("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Headers("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Headers("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Headers("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Headers("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().OneOf(1, 2),
			Expect().Headers("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").Len().OneOf(1, 2),
			Expect().Headers("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Headers("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Headers("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotEmpty(),
			Expect().Headers("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Headers().NotEmpty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotEmpty(),
			Expect().Headers("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").NotEmpty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Headers("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Headers("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Headers("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Headers("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").NotOneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectHeadersOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Headers("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectHeadersOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Headers("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Headers("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Headers("Foo-Bar").OneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatus(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().Between(2, 2),
			Expect().Status().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Status(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().Between(2, 2),
			Expect().Status().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Status().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().Between(2, 2),
			Expect().Status().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Status().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().Equal(2),
			Expect().Status().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Status().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().Equal(2),
			Expect().Status().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Status().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().GreaterOrEqualThan(2),
			Expect().Status().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().GreaterOrEqualThan(2),
			Expect().Status().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().GreaterThan(2),
			Expect().Status().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().GreaterThan(2),
			Expect().Status().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().LessOrEqualThan(2),
			Expect().Status().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().LessOrEqualThan(2),
			Expect().Status().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().LessThan(2),
			Expect().Status().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().LessThan(2),
			Expect().Status().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Status().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotBetween(2, 2),
			Expect().Status().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Status().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotBetween(2, 2),
			Expect().Status().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Status().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotEqual(1, 2),
			Expect().Status().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotEqual(1, 2),
			Expect().Status().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotOneOf(1, 2),
			Expect().Status().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().NotOneOf(1, 2),
			Expect().Status().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectStatusOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().OneOf(1, 2),
			Expect().Status().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectStatusOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Status().OneOf(1, 2),
			Expect().Status().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Status().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailers(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Trailers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Trailers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().Contains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Contains("Foo", "Baz"),
			Expect().Trailers("Hello-World").Contains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Contains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Empty(),
			Expect().Trailers("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Trailers().Empty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Empty(),
			Expect().Trailers("Hello-World").Empty(),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Empty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Trailers("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Equal("Foo", "Baz"),
			Expect().Trailers("Hello-World").Equal("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Equal("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLen(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().Between(2, 2),
			Expect().Trailers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().Between(2, 2),
			Expect().Trailers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().Between(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().Between(2, 2),
			Expect().Trailers("Hello-World").Len().Between(3, 3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().Between(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().Equal(2),
			Expect().Trailers("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().Equal(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().Equal(2),
			Expect().Trailers("Hello-World").Len().Equal(3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().Equal(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Trailers("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().GreaterOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenGreaterOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().GreaterOrEqualThan(2),
			Expect().Trailers("Hello-World").Len().GreaterOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().GreaterOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().GreaterThan(2),
			Expect().Trailers("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().GreaterThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenGreaterThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().GreaterThan(2),
			Expect().Trailers("Hello-World").Len().GreaterThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().GreaterThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Trailers("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().LessOrEqualThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenLessOrEqualThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().LessOrEqualThan(2),
			Expect().Trailers("Hello-World").Len().LessOrEqualThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().LessOrEqualThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().LessThan(2),
			Expect().Trailers("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().LessThan(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenLessThan(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().LessThan(2),
			Expect().Trailers("Hello-World").Len().LessThan(3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().LessThan(2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Trailers("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().NotBetween(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenNotBetween(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotBetween(2, 2),
			Expect().Trailers("Hello-World").Len().NotBetween(3, 3),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().NotBetween(2, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Trailers("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotEqual(1, 2),
			Expect().Trailers("Hello-World").Len().NotEqual(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().NotEqual(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Trailers("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().NotOneOf(1, 2),
			Expect().Trailers("Hello-World").Len().NotOneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().NotOneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().OneOf(1, 2),
			Expect().Trailers("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers().Len().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersLenOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").Len().OneOf(1, 2),
			Expect().Trailers("Hello-World").Len().OneOf(3, 4),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").Len().OneOf(1, 2),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().NotContains(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersNotContains(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotContains("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotContains("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").NotContains("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotEmpty(),
			Expect().Trailers("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Trailers().NotEmpty(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersNotEmpty(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotEmpty(),
			Expect().Trailers("Hello-World").NotEmpty(),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").NotEmpty(),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().NotEqual(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersNotEqual(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotEqual("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotEqual("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").NotEqual("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().NotOneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersNotOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").NotOneOf("Foo", "Baz"),
			Expect().Trailers("Hello-World").NotOneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").NotOneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Generic_ExpectTrailersOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Trailers("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers().OneOf(),
			expectSteps(t, &steps, 2)),
		PtrStr("TestOK"),
	)
}
func TestGenClear_Specific_ExpectTrailersOneOf(t *testing.T) {
	s := EchoServer()
	defer s.Close()
	var steps []IStep
	ExpectError(t,
		Do(
			Post(s.URL),
			Expect().Trailers("Foo-Bar").OneOf("Foo", "Baz"),
			Expect().Trailers("Hello-World").OneOf("Hello", "Earth"),
			storeSteps(&steps),
			Clear().Expect().Trailers("Foo-Bar").OneOf("Foo", "Baz"),
			expectSteps(t, &steps, 1)),
		PtrStr("TestOK"),
	)
}
